apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "backend-user.fullname" . }}
  labels:
    {{- include "backend-user.labels" . | nindent 4 }}
spec:
{{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
{{- end }}
  selector:
    matchLabels:
      {{- include "backend-user.selectorLabels" . | nindent 6 }}
  template:
    metadata:
    {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      labels:
        {{- include "backend-user.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "backend-user.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          env: 
            - name: NODE_ENV
              valueFrom:
                configMapKeyRef:
                  name: questcode
                  key: NODE_ENV 
            - name: MONGO_URI
              valueFrom:
                secretKeyRef:
                  name: questcode
                  key: MONGO_URI
            - name: SECRET_OR_KEY
              valueFrom:
                secretKeyRef:
                  name: questcode
                  key: SECRET_OR_KEY
          livenessProbe:
            httpGet:
              path: /api/profile/test
              port: {{ .Values.service.targetPort }}
          readinessProbe:
            httpGet:
              path: /api/profile/test
              port: {{ .Values.service.targetPort }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
